Index: django/conf/global_settings.py
===================================================================
--- django/conf/global_settings.py	(revision 17914)
+++ django/conf/global_settings.py	(working copy)
@@ -407,6 +407,9 @@
 DEFAULT_TABLESPACE = ''
 DEFAULT_INDEX_TABLESPACE = ''
 
+# The default database schema to use for tables
+DEFAULT_SCHEMA = None
+
 # Default X-Frame-Options header value
 X_FRAME_OPTIONS = 'SAMEORIGIN'
 
Index: django/db/models/fields/related.py
===================================================================
--- django/db/models/fields/related.py	(revision 17914)
+++ django/db/models/fields/related.py	(working copy)
@@ -1,6 +1,6 @@
 from operator import attrgetter
 
-from django.db import connection, router
+from django.db import connection, router, QName
 from django.db.backends import util
 from django.db.models import signals, get_model
 from django.db.models.fields import (AutoField, Field, IntegerField,
@@ -568,11 +568,11 @@
             # dealing with PK values.
             fk = self.through._meta.get_field(self.source_field_name)
             source_col = fk.column
-            join_table = self.through._meta.db_table
             connection = connections[db]
             qn = connection.ops.quote_name
+            join_alias = connection.qname(self.through)
             qs = qs.extra(select={'_prefetch_related_val':
-                                      '%s.%s' % (qn(join_table), qn(source_col))})
+                                      '%s.%s' % (join_alias, qn(source_col))})
             select_attname = fk.rel.get_related_field().get_attname()
             return (qs,
                     attrgetter('_prefetch_related_val'),
@@ -1085,6 +1085,7 @@
         to = to.lower()
     meta = type('Meta', (object,), {
         'db_table': field._get_m2m_db_table(klass._meta),
+        'db_schema': field._get_m2m_db_schema(klass._meta),
         'managed': managed,
         'auto_created': klass,
         'app_label': klass._meta.app_label,
@@ -1121,8 +1122,12 @@
             through=kwargs.pop('through', None))
 
         self.db_table = kwargs.pop('db_table', None)
+        self.db_schema = kwargs.pop('db_schema', None)
         if kwargs['rel'].through is not None:
             assert self.db_table is None, "Cannot specify a db_table if an intermediary model is used."
+            assert self.db_schema is None, "Cannot specify a db_schema if an intermediary model is used."
+        # TODO: by default use the containing model's db_schema
+            
 
         Field.__init__(self, **kwargs)
 
@@ -1142,6 +1147,22 @@
             return util.truncate_name('%s_%s' % (opts.db_table, self.name),
                                       connection.ops.max_name_length())
 
+    def _get_m2m_db_schema(self, opts):
+        "Function that can be curried to provide the m2m schema name for this relation"
+        if self.rel.through is not None and self.rel.through._meta.db_schema:
+            return self.rel.through._meta.db_schema
+        elif self.db_schema:
+            return self.db_schema
+        else:
+            return opts.db_schema
+
+
+    def _get_m2m_qualified_name(self, opts):
+        "Function that can be curried to provide the qualified m2m table name for this relation"
+        schema = self._get_m2m_db_schema(opts)
+        table = self._get_m2m_db_table(opts)
+        return QName(schema, table, False)
+
     def _get_m2m_attr(self, related, attr):
         "Function that can be curried to provide the source accessor or DB column name for the m2m table"
         cache_attr = '_m2m_%s_cache' % attr
@@ -1212,6 +1233,9 @@
 
         # Set up the accessor for the m2m table name for the relation
         self.m2m_db_table = curry(self._get_m2m_db_table, cls._meta)
+        self.m2m_db_schema = curry(self._get_m2m_db_schema, cls._meta)
+        self.m2m_qualified_name = curry(self._get_m2m_qualified_name,
+                                        cls._meta)
 
         # Populate some necessary rel arguments so that cross-app relations
         # work correctly.
@@ -1223,7 +1247,7 @@
         if isinstance(self.rel.to, basestring):
             target = self.rel.to
         else:
-            target = self.rel.to._meta.db_table
+            target = self.rel.to._meta.qualified_name
         cls._meta.duplicate_targets[self.column] = (target, "m2m")
 
     def contribute_to_related_class(self, cls, related):
Index: django/db/models/query.py
===================================================================
--- django/db/models/query.py	(revision 17914)
+++ django/db/models/query.py	(working copy)
@@ -1558,7 +1558,7 @@
         A dict mapping column names to model field names.
         """
         if not hasattr(self, '_model_fields'):
-            converter = connections[self.db].introspection.table_name_converter
+            converter = connections[self.db].introspection.identifier_converter
             self._model_fields = {}
             for field in self.model._meta.fields:
                 name, column = field.get_attname_column()
Index: django/db/models/sql/query.py
===================================================================
--- django/db/models/sql/query.py	(revision 17914)
+++ django/db/models/sql/query.py	(working copy)
@@ -16,7 +16,6 @@
 from django.db.models import signals
 from django.db.models.expressions import ExpressionNode
 from django.db.models.fields import FieldDoesNotExist
-from django.db.models.query_utils import InvalidQuery
 from django.db.models.sql import aggregates as base_aggregates_module
 from django.db.models.sql.constants import *
 from django.db.models.sql.datastructures import EmptyResultSet, Empty, MultiJoin
@@ -59,7 +58,7 @@
     def get_columns(self):
         if self.cursor is None:
             self._execute_query()
-        converter = connections[self.using].introspection.table_name_converter
+        converter = connections[self.using].introspection.identifier_converter
         return [converter(column_meta[0])
                 for column_meta in self.cursor.description]
 
@@ -638,7 +637,7 @@
         Callback used by deferred_to_columns(). The "target" parameter should
         be a set instance.
         """
-        table = model._meta.db_table
+        table = model._meta.qualified_name
         if table not in target:
             target[table] = set()
         for field in fields:
@@ -659,10 +658,13 @@
             self.alias_refcount[alias] += 1
             return alias, False
 
-        # Create a new alias for this table.
-        if current:
+        # Create a new alias for this table if this table is already used
+        # in the query, or if there is the same table name used in the query
+        # under different schema qualified name.
+        if current or table_name[1] in [t[1] for t in self.tables]:
             alias = '%s%d' % (self.alias_prefix, len(self.alias_map) + 1)
-            current.append(alias)
+            if current:
+                current.append(alias)
         else:
             # The first occurence of a table uses the table name directly.
             alias = table_name
@@ -832,7 +834,7 @@
             alias = self.tables[0]
             self.ref_alias(alias)
         else:
-            alias = self.join((None, self.model._meta.db_table, None, None))
+            alias = self.join((None, self.model._meta.qualified_name, None, None))
         return alias
 
     def count_active_tables(self):
@@ -945,7 +947,7 @@
                     seen[model] = root_alias
                 else:
                     link_field = opts.get_ancestor_link(model)
-                    seen[model] = self.join((root_alias, model._meta.db_table,
+                    seen[model] = self.join((root_alias, model._meta.qualified_name,
                             link_field.column, model._meta.pk.column))
         self.included_inherited_models = seen
 
@@ -1329,7 +1331,7 @@
                                     (id(opts), lhs_col), ()))
                             dupe_set.add((opts, lhs_col))
                         opts = int_model._meta
-                        alias = self.join((alias, opts.db_table, lhs_col,
+                        alias = self.join((alias, opts.qualified_name, lhs_col,
                                 opts.pk.column), exclusions=exclusions)
                         joins.append(alias)
                         exclusions.add(alias)
@@ -1355,12 +1357,12 @@
                         (table1, from_col1, to_col1, table2, from_col2,
                                 to_col2, opts, target) = cached_data
                     else:
-                        table1 = field.m2m_db_table()
+                        table1 = field.m2m_qualified_name()
                         from_col1 = opts.get_field_by_name(
                             field.m2m_target_field_name())[0].column
                         to_col1 = field.m2m_column_name()
                         opts = field.rel.to._meta
-                        table2 = opts.db_table
+                        table2 = opts.qualified_name
                         from_col2 = field.m2m_reverse_name()
                         to_col2 = opts.get_field_by_name(
                             field.m2m_reverse_target_field_name())[0].column
@@ -1388,7 +1390,7 @@
                     else:
                         opts = field.rel.to._meta
                         target = field.rel.get_related_field()
-                        table = opts.db_table
+                        table = opts.qualified_name
                         from_col = field.column
                         to_col = target.column
                         orig_opts._join_cache[name] = (table, from_col, to_col,
@@ -1410,12 +1412,12 @@
                         (table1, from_col1, to_col1, table2, from_col2,
                                 to_col2, opts, target) = cached_data
                     else:
-                        table1 = field.m2m_db_table()
+                        table1 = field.m2m_qualified_name()
                         from_col1 = opts.get_field_by_name(
                             field.m2m_reverse_target_field_name())[0].column
                         to_col1 = field.m2m_reverse_name()
                         opts = orig_field.opts
-                        table2 = opts.db_table
+                        table2 = opts.qualified_name
                         from_col2 = field.m2m_column_name()
                         to_col2 = opts.get_field_by_name(
                             field.m2m_target_field_name())[0].column
@@ -1439,7 +1441,7 @@
                         local_field = opts.get_field_by_name(
                                 field.rel.field_name)[0]
                         opts = orig_field.opts
-                        table = opts.db_table
+                        table = opts.qualified_name
                         from_col = local_field.column
                         to_col = field.column
                         # In case of a recursive FK, use the to_field for
@@ -1722,7 +1724,7 @@
         else:
             opts = self.model._meta
             if not self.select:
-                count = self.aggregates_module.Count((self.join((None, opts.db_table, None, None)), opts.pk.column),
+                count = self.aggregates_module.Count((self.join((None, opts.qualified_name, None, None)), opts.pk.column),
                                          is_summary=True, distinct=True)
             else:
                 # Because of SQL portability issues, multi-column, distinct
Index: django/db/models/sql/subqueries.py
===================================================================
--- django/db/models/sql/subqueries.py	(revision 17914)
+++ django/db/models/sql/subqueries.py	(working copy)
@@ -41,7 +41,7 @@
             where = self.where_class()
             where.add((Constraint(None, field.column, field), 'in',
                     pk_list[offset:offset + GET_ITERATOR_CHUNK_SIZE]), AND)
-            self.do_query(self.model._meta.db_table, where, using=using)
+            self.do_query(self.model._meta.qualified_name, where, using=using)
 
 class UpdateQuery(Query):
     """
Index: django/db/models/sql/compiler.py
===================================================================
--- django/db/models/sql/compiler.py	(revision 17914)
+++ django/db/models/sql/compiler.py	(working copy)
@@ -1,7 +1,8 @@
 from itertools import izip
 
+from django.conf import settings
 from django.core.exceptions import FieldError
-from django.db import transaction
+from django.db import transaction, QName
 from django.db.backends.util import truncate_name
 from django.db.models.query_utils import select_related_descend
 from django.db.models.sql.constants import *
@@ -27,7 +28,7 @@
         # cleaned. We are not using a clone() of the query here.
         """
         if not self.query.tables:
-            self.query.join((None, self.query.model._meta.db_table, None, None))
+            self.query.join((None, self.query.model._meta.qualified_name, None, None))
         if (not self.query.select and self.query.default_cols and not
                 self.query.included_inherited_models):
             self.query.setup_inherited_models()
@@ -42,11 +43,13 @@
         """
         if name in self.quote_cache:
             return self.quote_cache[name]
-        if ((name in self.query.alias_map and name not in self.query.table_map) or
-                name in self.query.extra_select):
+        if name in self.query.alias_map and not isinstance(name, tuple):
             self.quote_cache[name] = name
             return name
-        r = self.connection.ops.quote_name(name)
+        if isinstance(name, tuple):
+            r = self.connection.ops.qualified_name(name)
+        else:
+            r = self.connection.ops.quote_name(name)
         self.quote_cache[name] = r
         return r
 
@@ -281,8 +284,10 @@
                         alias = start_alias
                     else:
                         link_field = opts.get_ancestor_link(model)
-                        alias = self.query.join((start_alias, model._meta.db_table,
-                                link_field.column, model._meta.pk.column))
+                        alias = self.query.join((start_alias,
+                                                 model._meta.qualified_name,
+                                                 link_field.column,
+                                                 model._meta.pk.column))
                     seen[model] = alias
             else:
                 # If we're starting from the base model of the queryset, the
@@ -508,15 +513,12 @@
         qn2 = self.connection.ops.quote_name
         first = True
         for alias in self.query.tables:
-            if not self.query.alias_refcount[alias]:
+            # Extra tables can end up in self.tables, but not in the
+            # alias_map if they aren't in a join. That's OK. We skip them.
+            if not self.query.alias_refcount[alias] or alias not in self.query.alias_map:
                 continue
-            try:
-                name, alias, join_type, lhs, lhs_col, col, nullable = self.query.alias_map[alias]
-            except KeyError:
-                # Extra tables can end up in self.tables, but not in the
-                # alias_map if they aren't in a join. That's OK. We skip them.
-                continue
-            alias_str = (alias != name and ' %s' % alias or '')
+            name, alias, join_type, lhs, lhs_col, col, nullable = self.query.alias_map[alias]
+            alias_str = alias != name and ' %s' % qn(alias) or ''
             if join_type and not first:
                 result.append('%s %s%s ON (%s.%s = %s.%s)'
                         % (join_type, qn(name), alias_str, qn(lhs),
@@ -526,13 +528,17 @@
                 result.append('%s%s%s' % (connector, qn(name), alias_str))
             first = False
         for t in self.query.extra_tables:
-            alias, unused = self.query.table_alias(t)
-            # Only add the alias if it's not already present (the table_alias()
-            # calls increments the refcount, so an alias refcount of one means
-            # this is the only reference.
-            if alias not in self.query.alias_map or self.query.alias_refcount[alias] == 1:
+            # Plain string table names are assumed to be in default schema
+            if not isinstance(t, QName):
+                t = QName(self.connection.schema, t, False)
+            # Only add the table if it is not already in the query.
+            if t not in self.query.table_map or self.query.alias_refcount[t] == 0:
+                # This will add the table into the query properly, however we
+                # are not interested in the alias it gets, we add it as a
+                # plain table.
+                self.query.table_alias(t)
                 connector = not first and ', ' or ''
-                result.append('%s%s' % (connector, qn(alias)))
+                result.append('%s%s' % (connector, qn(t)))
                 first = False
         return result, []
 
@@ -546,7 +552,7 @@
             if (len(self.query.model._meta.fields) == len(self.query.select) and
                 self.connection.features.allows_group_by_pk):
                 self.query.group_by = [
-                    (self.query.model._meta.db_table, self.query.model._meta.pk.column)
+                    (self.query.model._meta.qualified_name, self.query.model._meta.pk.column)
                 ]
 
             group_by = self.query.group_by or []
@@ -614,7 +620,7 @@
             # what "used" specifies).
             avoid = avoid_set.copy()
             dupe_set = orig_dupe_set.copy()
-            table = f.rel.to._meta.db_table
+            table = f.rel.to._meta.qualified_name
             promote = nullable or f.null
             if model:
                 int_opts = opts
@@ -635,7 +641,7 @@
                                 ()))
                         dupe_set.add((opts, lhs_col))
                     int_opts = int_model._meta
-                    alias = self.query.join((alias, int_opts.db_table, lhs_col,
+                    alias = self.query.join((alias, int_opts.qualified_name, lhs_col,
                             int_opts.pk.column), exclusions=used,
                             promote=promote)
                     alias_chain.append(alias)
@@ -687,7 +693,7 @@
                 # what "used" specifies).
                 avoid = avoid_set.copy()
                 dupe_set = orig_dupe_set.copy()
-                table = model._meta.db_table
+                table = model._meta.qualified_name
 
                 int_opts = opts
                 alias = root_alias
@@ -710,7 +716,7 @@
                             dupe_set.add((opts, lhs_col))
                         int_opts = int_model._meta
                         alias = self.query.join(
-                            (alias, int_opts.db_table, lhs_col, int_opts.pk.column),
+                            (alias, int_opts.qualified_name, lhs_col, int_opts.pk.column),
                             exclusions=used, promote=True, reuse=used
                         )
                         alias_chain.append(alias)
@@ -775,7 +781,7 @@
                         # into `resolve_columns` because it wasn't selected.
                         only_load = self.deferred_to_columns()
                         if only_load:
-                            db_table = self.query.model._meta.db_table
+                            db_table = self.query.model._meta.qualified_name
                             fields = [f for f in fields if db_table in only_load and
                                       f.column in only_load[db_table]]
                     row = self.resolve_columns(row, fields)
@@ -856,8 +862,9 @@
         # We don't need quote_name_unless_alias() here, since these are all
         # going to be column names (so we can avoid the extra overhead).
         qn = self.connection.ops.quote_name
+        qn3 = self.connection.ops.qualified_name
         opts = self.query.model._meta
-        result = ['INSERT INTO %s' % qn(opts.db_table)]
+        result = ['INSERT INTO %s' % qn3(opts.qualified_name)]
 
         has_fields = bool(self.query.fields)
         fields = self.query.fields if has_fields else [opts.pk]
@@ -887,7 +894,7 @@
             ]
         if self.return_id and self.connection.features.can_return_id_from_insert:
             params = params[0]
-            col = "%s.%s" % (qn(opts.db_table), qn(opts.pk.column))
+            col = "%s.%s" % (qn3(opts.qualified_name), qn(opts.pk.column))
             result.append("VALUES (%s)" % ", ".join(placeholders[0]))
             r_fmt, r_params = self.connection.ops.return_insert_id()
             result.append(r_fmt % col)
@@ -913,7 +920,7 @@
         if self.connection.features.can_return_id_from_insert:
             return self.connection.ops.fetch_returned_insert_id(cursor)
         return self.connection.ops.last_insert_id(cursor,
-                self.query.model._meta.db_table, self.query.model._meta.pk.column)
+                self.query.model._meta.qualified_name, self.query.model._meta.pk.column)
 
 
 class SQLDeleteCompiler(SQLCompiler):
@@ -939,9 +946,15 @@
         self.pre_sql_setup()
         if not self.query.values:
             return '', ()
-        table = self.query.tables[0]
+        opts = self.query.model._meta
+        table = self.connection.ops.qualified_name(opts.qualified_name)
         qn = self.quote_name_unless_alias
-        result = ['UPDATE %s' % qn(table)]
+        alias = qn(self.query.tables[0])
+        if table == alias:
+            alias = ''
+        else:
+            alias = ' %s' % alias
+        result = ['UPDATE %s%s' % (table, alias)]
         result.append('SET')
         values, update_params = [], []
         for field, model, val in self.query.values:
Index: django/db/models/options.py
===================================================================
--- django/db/models/options.py	(revision 17914)
+++ django/db/models/options.py	(working copy)
@@ -2,6 +2,7 @@
 from bisect import bisect
 
 from django.conf import settings
+from django.db import QName
 from django.db.models.related import RelatedObject
 from django.db.models.fields.related import ManyToManyRel
 from django.db.models.fields import AutoField, FieldDoesNotExist
@@ -17,7 +18,7 @@
 DEFAULT_NAMES = ('verbose_name', 'verbose_name_plural', 'db_table', 'ordering',
                  'unique_together', 'permissions', 'get_latest_by',
                  'order_with_respect_to', 'app_label', 'db_tablespace',
-                 'abstract', 'managed', 'proxy', 'auto_created')
+                 'abstract', 'managed', 'proxy', 'auto_created', 'db_schema')
 
 class Options(object):
     def __init__(self, meta, app_label=None):
@@ -26,6 +27,8 @@
         self.module_name, self.verbose_name = None, None
         self.verbose_name_plural = None
         self.db_table = ''
+        self.db_schema = ''
+        self.qualified_name = QName(schema=None, table='', db_format=False)
         self.ordering = []
         self.unique_together =  []
         self.permissions =  []
@@ -112,7 +115,12 @@
         # If the db_table wasn't provided, use the app_label + module_name.
         if not self.db_table:
             self.db_table = "%s_%s" % (self.app_label, self.module_name)
+            # TODO: Using connection.ops is wrong: in multidb setup this doesn't work
+            # correctly except if different connections happen to have the same
+            # max_name_length.
             self.db_table = truncate_name(self.db_table, connection.ops.max_name_length())
+        self.qualified_name = QName(schema=self.db_schema, table=self.db_table,
+                                    db_format=False)
 
     def _prepare(self, model):
         if self.order_with_respect_to:
@@ -193,6 +201,8 @@
         self.pk = target._meta.pk
         self.proxy_for_model = target
         self.db_table = target._meta.db_table
+        self.db_schema = target._meta.db_schema
+        self.qualified_name = target._meta.qualified_name
 
     def __repr__(self):
         return '<Options for %s>' % self.object_name
Index: django/db/__init__.py
===================================================================
--- django/db/__init__.py	(revision 17914)
+++ django/db/__init__.py	(working copy)
@@ -3,11 +3,17 @@
 from django.core.exceptions import ImproperlyConfigured
 from django.db.utils import (ConnectionHandler, ConnectionRouter,
     load_backend, DEFAULT_DB_ALIAS, DatabaseError, IntegrityError)
+from collections import namedtuple
 
+# All table names must be QNames. The db_format argument
+# tells if the qualified name is in a format that is ready
+# to be used in the database or if the qname needs to be
+# converted first.
+QName = namedtuple("QName", "schema table db_format")
+
 __all__ = ('backend', 'connection', 'connections', 'router', 'DatabaseError',
     'IntegrityError', 'DEFAULT_DB_ALIAS')
 
-
 if DEFAULT_DB_ALIAS not in settings.DATABASES:
     raise ImproperlyConfigured("You must define a '%s' database" % DEFAULT_DB_ALIAS)
 
Index: django/db/utils.py
===================================================================
--- django/db/utils.py	(revision 17914)
+++ django/db/utils.py	(working copy)
@@ -78,10 +78,17 @@
             conn['ENGINE'] = 'django.db.backends.dummy'
         conn.setdefault('OPTIONS', {})
         conn.setdefault('TIME_ZONE', 'UTC' if settings.USE_TZ else settings.TIME_ZONE)
-        for setting in ['NAME', 'USER', 'PASSWORD', 'HOST', 'PORT']:
+        conn.setdefault('SCHEMA', settings.DEFAULT_SCHEMA)
+        for setting in ['NAME', 'USER', 'PASSWORD', 'HOST', 'PORT', 'SCHEMA']:
             conn.setdefault(setting, '')
         for setting in ['TEST_CHARSET', 'TEST_COLLATION', 'TEST_NAME', 'TEST_MIRROR']:
             conn.setdefault(setting, None)
+        # Some databases need a unique prefix for schemas to avoid name
+        # collisions between production database or another testing database
+        # in the same instance. This needs to be a string unlike the other
+        # TEST_ settings above.
+        conn.setdefault('TEST_SCHEMA_PREFIX', '')
+        conn.setdefault('TEST_SCHEMAS', [])
 
     def __getitem__(self, alias):
         if hasattr(self._connections, alias):
